import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * This class Add one block of "10" -200 of this object.
 * 
 * @author Ton Tran 
 * @version 1
 */
public class AddBlock10 extends Actor
{
    World _World;
    /**
     * This gets the world
     */
    public AddBlock10(MyWorld world)
    {
        _World = world;
    }

    /**
     * Act - do whatever the AddBlock10 wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act()
    {
        // Add your action code here.
        if (Greenfoot.mouseClicked(this) && getWorldOfType(MyWorld.class).clicking)
        {
            getWorldOfType(MyWorld.class).clicking = false;
        }
        mousePickUpBlock();
    }

    /**
     * This method spawns in a new 10 Block 
     */
    public void mousePickUpBlock()
    {
        if (Greenfoot.mouseClicked(this))
        {
            _World.addObject(new Block10() , getX() , getY() + 200);
        }
    }
}
