import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)

/**
 * This is the abtracted class for the blocks.
 * 
 * @author Ton Tran
 * @version 1
 */
public abstract class Block extends Actor
{
    private boolean mouseDown = false;
    public int value;

    public void act()
    {
        // Add your action code here.
        if (Greenfoot.mouseClicked(this) && getWorldOfType(MyWorld.class).clicking)
        {
            getWorldOfType(MyWorld.class).clicking = false;
        }
        //System.out.println(Greenfoot.mouseDragged(this));
    }
    /**
     * This method allows the blocks to be picked up
     */
    public void mousePickUpBlock()
    {
        if (Greenfoot.mousePressed(this))
        {
            mouseDown = true;
        }
        if (Greenfoot.mouseClicked(this)) 
        {
            mouseDown = false;
        }
        if (Greenfoot.getMouseInfo() != null && mouseDown) 
        {
            setLocation(Greenfoot.getMouseInfo().getX() , Greenfoot.getMouseInfo().getY());
        }

    }

}
