import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.util.ArrayList;

/**
 * This class takes in Generic type of "Block" to merge them
 * 
 * @author Ton Tran
 * @version 1
 */
public class Merge extends Actor
{
    private boolean mousePressed = false;
    public int totalValueOfBlocks = 0; 
    /**
     * Act - do whatever the Merge wants to do. This method is called whenever
     * the 'Act' or 'Run' button gets pressed in the environment.
     */
    public void act()
    {
        if (Greenfoot.mouseClicked(this) && getWorldOfType(MyWorld.class).clicking)
        {
            getWorldOfType(MyWorld.class).clicking = false;
        }
        if (Greenfoot.mousePressed(this))
        {
            mergeBlocks();
        }
    }
    /**
     * mergeBlocks uses the array from selectedBlocks to "merge" them 
     */
    public void mergeBlocks()
    {
        for (int j = 0; j < 4; j++)
        {
            ArrayList<Block> array = new ArrayList<Block>();
            for (int i = 0 ; i < getWorldOfType(MyWorld.class).selectedBlocks().size() ; i++)
            {
                if (getWorldOfType(MyWorld.class).blockType[j] == getWorldOfType(MyWorld.class).selectedBlocks().get(i).getClass())
                {
                    array.add(getWorldOfType(MyWorld.class).selectedBlocks().get(i));
                }
            }
            for (int i = 0; i < array.size() / 10; i++)
            {
                Block parent = array.get(i * 10);
                for (int b = 0 ; b < 10; b++)
                {
                    array.get(b).setLocation(parent.getX() + b * 21, parent.getY());
                }
                for (int b = 0 ; b < 10; b++)
                {
                    if  (array.get(b) == parent)
                    {
                        switch (parent.value) {
                            case 1:
                                getWorldOfType(MyWorld.class).addObject(new Block10(), parent.getX(), parent.getY());
                                break;
                            case 10:
                                getWorldOfType(MyWorld.class).addObject(new Block100(), parent.getX(), parent.getY());
                                break;
                            case 100:
                                getWorldOfType(MyWorld.class).addObject(new Block1000(), parent.getX(), parent.getY());
                                break;
                        }
                        getWorldOfType(MyWorld.class).removeObject(parent);
                    }
                    else 
                    {
                        getWorldOfType(MyWorld.class).removeObject(array.get(b));
                    }
                }
            }
        }
    }
}
